' io.i
  Run-time library Release 1
  Copyright (c) 1995 by Per Lidn
'

?ifndef __IO_I__;
 const __IO_I__;

' Open Modes '
const omCREATE    =  0; ' Create file read/write '
const omOPEN      =  1; ' Open file read/write '
const omREAD      =  2; ' Open file read only '
const omWRITE     =  3; ' Open file write only '

' File Attributes '
const faREADONLY  =  01h;
const faHIDDEN    =  02h;
const faSYSFILE   =  04h;
const faVOLUMEID  =  08h;
const faDIRECTORY =  10h;
const faARCHIVE   =  20h;
const faANYFILE   =  3Fh;

' I/O Functions '
_import _far int   openf(point __name,int __mode);
_import _far none  closef(int __handle);
_import _far int   writef(int __handle,point __buffer,int __size);
_import _far int   readf(int __handle,point __buffer,int __size);
_import _far lint  getfpos(int __handle);
_import _far none  setfpos(int __handle,lint __distance);
_import _far lint  setfposrel(int __handle,lint __distance);
_import _far lint  setfposend(int __handle,lint __distance);
_import _far none  deletef(point __name);
_import _far none  renamef(point __name,point __newname);
_import _far lint  filesize(int __handle);
_import _far int   eof(int __handle);
_import _far int   pioerr(point __msg);

link <io;

?endif;

?ifndef __IORESULT__;
 const __IORESULT__;

' I/O Result '
int IORESULT = 0;

?endif;

?ifndef __STDIOLIB__;
 const __STDIOLIB__;

link <stdio;

?endif;