;---------------------------------------------------;
;     PAL Startup code for DOS                      ;
;                                                   ;
;     Run-Time Library - Release 1                  ;
;     Copyright (c) 1995 by Per Lidn               ;
;     All Rights Reserved.                          ;
;---------------------------------------------------;

.386P
smart
jumps
locals  @@

assume	cs:STARTUPL_TEXT,ds:_DATA
_DATA	segment word public use16 'DATA'
        __386DXerror      db "This program minimum requires an 80386 CPU with an 80387 math co-processor...",10,13,"$"
        __Releaseerr      db "Error when releasing memory...",10,13,"$"
        __LastSeg         dw SEG ___Lastseg
        __SaveINT6_7      dd ?
        __MathTest        dd 1.1
_DATA	ends

extrn __PSP:word       ; Program Segment Prifix
extrn _START:far       ; main program

STARTUPL_TEXT	segment byte public use16 'CODE'

assume cs:STARTUPL_TEXT
__startupcode   proc  near
                mov ax,SEG _DATA
                mov ds,ax
                assume ds:_DATA

                mov  __PSP,es         ; Spara Program Segment Prifix i PSP
                call __check80386DX   ; Kolla s att det minst r en 386DX
                call __release_mem    ; Frigr verfldigt minne
                finit                 ; Init. matte-processorn

                call _START           ; Starta huvudprogrammet

                push ax
                call far ptr _exit
__startupcode   endp


assume cs:STARTUPL_TEXT
public _exit
_exit proc far
      push bp
      mov bp,sp
      mov ax,word ptr [bp+6]  ; AL = ExitCode
      mov ah,4Ch
      int 21h
_exit endp


assume cs:STARTUPL_TEXT
__release_mem proc near
          mov es,__PSP
          mov bx,__LastSeg
          mov ax,__PSP
          sub bx,ax
          mov  ah,4Ah
          int  21h
          jc @@faild
          ret
   @@faild:
          mov dx,offset __Releaseerr
          mov ah,9
          int 21h
          push 100
          call far ptr _exit
__release_mem endp


assume cs:STARTUPL_TEXT
__check80386DX proc near
         ;Kolla 80386
         mov ax,3506h
         int 21h
         mov word ptr __SaveINT6_7, bx
         mov word ptr __SaveINT6_7+2, es
         push ds
         push cs
         pop ds
         mov dx,offset @@not386dx
         mov ax,2506h
         int 21h
         pop ds
         inc eax   ; Om inte 386 hopp till @@not386dx
         push dx   ; Annars terstll int 06h
         push ds
         mov dx, word ptr __SaveINT6_7
         mov ds, word ptr __SaveINT6_7+2
         mov ax,2506h
         int 21h
         pop ds
         pop dx

       ;Det var en 80386 s kolla nu om det finns matte-processor
         mov ax,3507h
         int 21h
         mov word ptr __SaveINT6_7, bx
         mov word ptr __SaveINT6_7+2, es
         push ds
         push cs
         pop ds
         mov dx,offset @@not386dx
         mov ax,2507h
         int 21h
         pop ds
         fld dword ptr __MathTest  ; Om inte matte-processor hopp till @@not386dx
         fsin
         fstp dword ptr __MathTest
         push dx   ; Annars terstll int 07h
         push ds
         mov dx, word ptr __SaveINT6_7
         mov ds, word ptr __SaveINT6_7+2
         mov ax,2507h
         int 21h
         pop ds
         pop dx

        ;Om man kommit hit s r det en 386DX eller hgre
         ret
@@not386dx:
        ;Det var ingen 386DX eller hgre s d fr vi bryta hr
         pop ax ax ax

         mov dx,offset __386DXerror
         mov ah,9
         int 21h
         push 100
         call _exit
__check80386DX endp

STARTUPL_TEXT	ends

_DATA	segment word public use16 'DATA'
        __Copyright  db  "PAL Realese 1 Copyright (c) 1995 by Per Lidn"
_DATA	ends

___Lastseg  segment
___Lastseg  ends

end __startupcode

