' control.i
  Run-time library Release 1
  Copyright (c) 1995 by Per Lidn
'

?ifndef __CONTROL_I__;
 const __CONTROL_I__;

const rndNEAR   = 0;  'default'
const rndDOWN   = 1;
const rndUP     = 2;
const rndTRUNC  = 3;

const prec64bits = 3;  'default'
const prec53bits = 2;
const prec24bits = 0;

' FPU Control '
_import _far int  getFPUcw();
_import _far none setFPUcw(int __ctrlw);
_import _far none setFPUprec(int __prec);
_import _far none setFPUrnd(int __rnd);

' Misc '
_import _far none   delay(int __ms);
_import _far none   randomize();
_import _far dfloat random();
_import _far int    seg(point __p);
_import _far int    ofs(point __pointer);
_import _far point  ptr(int __seg,int __ofs);
_import _far int    ascii(char __ch);
_import _far int    hi(int __value);
_import _far int    low(int __value);
_import _far lint   hil(lint __value);
_import _far lint   lowl(lint __value);

?endif;

?ifndef __CONTROLLIB__;
 const __CONTROLLIB__;

link <control;

?endif;

?ifndef __MATHLIB__;
 const __MATHLIB__;

link <math;

?endif;